Panda3D

Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
WebcamVideo Class Referenceabstract

Allows you to open a webcam or other video capture device as a video stream. More...

`#include "webcamVideo.h"`

Inheritance diagram for WebcamVideo:

## Public Member Functions
virtual TypeHandle | force_init_type ()
double | get_fps () const
| Returns the camera's framerate. More...
const std::string & | get_pixel_format () const
| Returns the camera's pixel format, as a FourCC code, if known. More...
int | get_size_x () const
| Returns the camera's size_x. More...
int | get_size_y () const
| Returns the camera's size_y. More...
virtual TypeHandle | get_type () const
void | output (std::ostream &out) const
| Outputs the WebcamVideo. More...
virtual | PT (MovieVideoCursor) open()=0
Public Member Functions inherited from MovieVideo
| MovieVideo (const std::string &name="Blank Video")
| This constructor returns a null video stream — a stream of plain blue and white frames that last one second each. More...
const Filename & | get_filename () const
const SubfileInfo & | get_subfile_info () const
virtual void | write_datagram (BamWriter *manager, Datagram &dg)
| Writes the contents of this object to the datagram for shipping out to a Bam file. More...
Public Member Functions inherited from TypedWritableReferenceCount
| TypedWritableReferenceCount (const TypedWritableReferenceCount &copy)
virtual ReferenceCount * | as_reference_count ()
| Returns the pointer cast to a ReferenceCount pointer, if it is in fact of that type. More...
void | operator= (const TypedWritableReferenceCount &copy)
Public Member Functions inherited from TypedWritable
| TypedWritable (const TypedWritable &copy)
virtual int | complete_pointers (TypedWritable **p_list, BamReader *manager)
| Receives an array of pointers, one for each time manager->read_pointer() was called in fillin(). More...
vector_uchar | encode_to_bam_stream () const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and returns that data as a bytes object. More...
bool | encode_to_bam_stream (vector_uchar &data, BamWriter *writer=nullptr) const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and stores that data in the indicated string. More...
virtual void | finalize (BamReader *manager)
| Called by the BamReader to perform any final actions needed for setting up the object after all objects have been read and all pointers have been completed. More...
UpdateSeq | get_bam_modified () const
| Returns the current bam_modified counter. More...
void | mark_bam_modified ()
| Increments the bam_modified counter, so that this object will be invalidated and retransmitted on any open bam streams. More...
void | operator= (const TypedWritable &copy)
virtual bool | require_fully_complete () const
| Some objects require all of their nested pointers to have been completed before the objects themselves can be completed. More...
virtual void | update_bam_nested (BamWriter *manager)
| Called by the BamWriter when this object has not itself been modified recently, but it should check its nested objects for updates. More...
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer. More...
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer. More...
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type. More...
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly. More...
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type. More...
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object. More...
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise. More...
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack. More...
void | ref () const
| Explicitly increments the reference count. More...
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero. More...
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus. More...
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus. More...
virtual bool | unref () const
| Explicitly decrements the reference count. More...
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one. More...
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object. More...
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object. More...
Public Member Functions inherited from Namable
| Namable (const std::string &initial_name="")
void | clear_name ()
| Resets the Namable's name to empty. More...
const std::string & | get_name () const
bool | has_name () const
| Returns true if the Namable has a nonempty name set, false if the name is empty. More...
void | output (std::ostream &out) const
| Outputs the Namable. More...
void | set_name (const std::string &name)

## Static Public Member Functions
static void | find_all_webcams ()
| Scans the hardware for webcams, and pushes them onto the global list of all webcams. More...
static TypeHandle | get_class_type ()
static int | get_num_options ()
static void | init_type ()
static | PT (WebcamVideo) get_option(int n)
Static Public Member Functions inherited from MovieVideo
static TypeHandle | get_class_type ()
static void | init_type ()
static | PT (MovieVideo) get(const Filename &name)
Static Public Member Functions inherited from TypedWritableReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
static | PT (TypedWritableReferenceCount) decode_from_bam_stream(vector_uchar data
Static Public Member Functions inherited from TypedWritable
static bool | decode_raw_from_bam_stream (TypedWritable *&ptr, ReferenceCount *&ref_ptr, vector_uchar data, BamReader *reader=nullptr)
| Reads the bytes created by a previous call to encode_to_bam_stream(), and extracts the single object on those bytes. More...
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96. More...
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from Namable
static TypeHandle | get_class_type ()
static void | init_type ()

## Public Attributes
| get_num_options
| Returns the number of webcam options. More...
| get_option
Public Attributes inherited from MovieVideo
| get_filename
| Returns the movie's filename. More...
| get_subfile_info
| If the movie is to be loaded from a subfile on disk, this returns the subfile info. More...
Public Attributes inherited from TypedWritableReferenceCount
static BamReader * | reader = nullptr)
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count. More...
Public Attributes inherited from Namable
| get_name
| set_name

## Additional Inherited Members
Static Public Attributes inherited from TypedWritable
static TypedWritable *const | Null = nullptr

## Detailed Description

Allows you to open a webcam or other video capture device as a video stream.

Definition at line 23 of file webcamVideo.h.

## Member Function Documentation

## ◆ find_all_webcams()

void WebcamVideo::find_all_webcams | ( |  | ) |
| static

Scans the hardware for webcams, and pushes them onto the global list of all webcams.

There are several implementations of WebcamVideo, including one based on DirectShow, one based on Video4Linux, and so forth. These implementations are contained in one C++ file each, and they export nothing at all except a single "find_all" function. Otherwise, they can only be accessed through the virtual methods of the WebcamVideo objects they create.

Definition at line 39 of file webcamVideo.cxx.

Referenced by PT().

## ◆ get_fps()

double WebcamVideo::get_fps | ( |  | ) | const
| inline

Returns the camera's framerate.

This is a maximum theoretical: the actual performance will depend on the speed of the hardware.

Definition at line 34 of file webcamVideo.I.

## ◆ get_pixel_format()

const std::string & WebcamVideo::get_pixel_format | ( |  | ) | const
| inline

Returns the camera's pixel format, as a FourCC code, if known.

Definition at line 42 of file webcamVideo.I.

## ◆ get_size_x()

int WebcamVideo::get_size_x | ( |  | ) | const
| inline

Returns the camera's size_x.

Definition at line 17 of file webcamVideo.I.

## ◆ get_size_y()

int WebcamVideo::get_size_y | ( |  | ) | const
| inline

Returns the camera's size_y.

Definition at line 25 of file webcamVideo.I.

## ◆ output()

void WebcamVideo::output | ( | std::ostream & | out | ) | const
| inline

Outputs the WebcamVideo.

This function simply writes the name, size and FPS to the output stream.

Definition at line 51 of file webcamVideo.I.

## Member Data Documentation

## ◆ get_num_options

int WebcamVideo::get_num_options

Returns the number of webcam options.

An "option" consists of a device plus a set of configuration parameters. For example, "Creative Webcam Live at 640x480, 30 fps" is an option.

Definition at line 30 of file webcamVideo.h.

The documentation for this class was generated from the following files:

- panda/src/vision/webcamVideo.h
- panda/src/vision/webcamVideo.cxx
- panda/src/vision/webcamVideo.I